/* dipole.f -- translated by f2c (version 20000121).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

//#include "f2c.h"

#define doublereal double

/* Table of constant values */

static doublereal c_b2 = 0.;

/* Subroutine */ int dipole_(doublereal *xq, doublereal *yq, doublereal *zq, 
	doublereal *a, doublereal *mi, doublereal *md, doublereal *m, 
	doublereal *xp, doublereal *yp, doublereal *zp, doublereal *bx, 
	doublereal *by, doublereal *bz)
{
    /* Initialized data */

    static doublereal pi = 3.14159265;
    static doublereal t2nt = 1e9;
    static doublereal cm = 1e-7;

    /* System generated locals */
    doublereal d__1, d__2, d__3;

    /* Builtin functions */
    double sqrt(doublereal);

    /* Local variables */
    static doublereal r__, r2, r5, mx, my, mz, rx, ry, rz;
    extern /* Subroutine */ int dircos_(doublereal *, doublereal *, 
	    doublereal *, doublereal *, doublereal *, doublereal *);
    static doublereal moment, dot;


/*  Subroutine DIPOLE computes the three components of magnetic */
/*  induction caused by a uniformly magnetized sphere.  X Axis */
/*  is north, z axis is down. */

/*  Input parameters: */
/*    Observation point located at (xp,yp,zp).  Sphere centered */
/*    at (xq,yq,zq).  Magnetization of sphere defined by */
/*    intensity m, inclination mi, and declination md.  Units */
/*    of distance irrelevant but must be consistent. All angles */
/*    in degrees.  Intensity of magnetization in A/m.  Requires */
/*    subroutine DIRCOS. */

/*  Output parameters: */
/*    The three components of magnetic induction (bx,by,bz) in */
/*    units of nT. */

    dircos_(mi, md, &c_b2, &mx, &my, &mz);
    rx = *xp - *xq;
    ry = *yp - *yq;
    rz = *zp - *zq;
/* Computing 2nd power */
    d__1 = rx;
/* Computing 2nd power */
    d__2 = ry;
/* Computing 2nd power */
    d__3 = rz;
    r2 = d__1 * d__1 + d__2 * d__2 + d__3 * d__3;
    r__ = sqrt(r2);
    if (r__ == 0.) {
	return 0;
    }
/* Computing 5th power */
    d__1 = r__, d__2 = d__1, d__1 *= d__1;
    r5 = d__2 * (d__1 * d__1);
    dot = rx * mx + ry * my + rz * mz;
/* Computing 3rd power */
    d__1 = *a;
    moment = pi * 4. * (d__1 * (d__1 * d__1)) * *m / 3;
    *bx = cm * moment * (dot * 3. * rx - r2 * mx) / r5;
    *by = cm * moment * (dot * 3. * ry - r2 * my) / r5;
    *bz = cm * moment * (dot * 3. * rz - r2 * mz) / r5;
    *bx *= t2nt;
    *by *= t2nt;
    *bz *= t2nt;
    return 0;
} /* dipole_ */

/* Subroutine */ int dircos_(doublereal *incl, doublereal *decl, doublereal *
	azim, doublereal *a, doublereal *b, doublereal *c__)
{
    /* Initialized data */

    static doublereal d2rad = .017453293;

    /* Builtin functions */
    double cos(doublereal), sin(doublereal);

    /* Local variables */
    static doublereal xdecl, xincl, xazim;


/*  Subroutine DIRCOS computes direction cosines from inclination */
/*  and declination. */

/*  Input parameters: */
/*    incl:  inclination in degrees positive below horizontal. */
/*    decl:  declination in degrees positive east of true north. */
/*    azim:  azimuth of x axis in degrees positive east of north. */

/*  Output parameters: */
/*    a,b,c:  the three direction cosines. */

    xincl = *incl * d2rad;
    xdecl = *decl * d2rad;
    xazim = *azim * d2rad;
    *a = cos(xincl) * cos(xdecl - xazim);
    *b = cos(xincl) * sin(xdecl - xazim);
    *c__ = sin(xincl);
    return 0;
} /* dircos_ */

